#include <bits/stdc++.h>
using namespace std;
#define pb push_back

const int N=55;
vector<int> E[N],G[N];
int col[N][N];
bool was[N];
bool in[N];
int dep[N];
void DFS(int u,int c=0){
    in[u]=true;
    was[u]=true;
    dep[u]=c;
    for(int v:E[u]){
        if(!was[v]){
            col[u][v]=c;
            DFS(v,(c+1)%3);
        }else if(in[v]){
            col[u][v]=(dep[v]+2)%3;
        }else{
            col[u][v]=c;
        }
    }
    in[u]=false;
}
vector<int> stk;
bool ok;
void Work(int u){
    in[u]=true;
    was[u]=true;
    for(int v:E[u]){
        if(!was[v]){
            Work(v);
        }else if(in[v]){
            ok=false;
        }
    }
    stk.push_back(u);
    in[u]=false;
}
bool CheckColors(int c1,int c2,int n){
     for(int i=1;i<=n;i++){
        E[i].clear();
        was[i]=false;
        in[i]=false;
    }
    //printf("Subgraph\n");
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            if(col[i][j]==c1 || col[i][j]==c2){
                E[i].pb(j);
                //printf("%i -> %i\n",i,j);
            }
        }
    }
    stk.clear();
    ok=true;
    for(int i=1;i<=n;i++){
        if(!was[i]){
            Work(i);
        }
    }
    return ok;
}
bool Check(int n){
    return CheckColors(0,1,n) && CheckColors(1,2,n) && CheckColors(2,0,n);
}
void Print(int c1,int c2,int n){
    bool ok=CheckColors(c1,c2,n);
    assert(ok);
    reverse(stk.begin(),stk.end());
    for(int i:stk)printf("%i ",i);
    printf("\n");
}
mt19937 rng(time(0));
int main(){
    while(true){
        int n,m;
        //scanf("%i %i",&n,&m);
        n=6;
        m=500;
        set<pair<int,int>> edgs;
        for(int i=1;i<=m;i++){
          int u=rng()%n+1;
          int v=rng()%n+1;
          if(u!=v && !edgs.count({u,v}) && !edgs.count({v,u})){
            edgs.insert({u,v});
            E[u].pb(v);
            G[u].pb(v);
          }
        }
        printf("%i %i\n",n,edgs.size());
        for(int i=1;i<=n;i++){
            for(int j:E[i])printf("%i %i\n",i,j);
        }
        for(int i=1;i<=n;i++)for(int j=1;j<=n;j++)col[i][j]=-1;
        /*for(int i=1;i<=m;i++){
            int u,v;
            scanf("%i %i",&u,&v);
            E[u].pb(v);
            G[u].pb(v);
        }*/
        bool solved=false;
        for(int z=0;z<100000;z++){
            //printf("Try %i\n",z);
            for(int i=1;i<=n;i++){
                for(int j:G[i]){
                    col[i][j]=rng()%3;
                    //printf("%i %i - %i\n",i,j,col[i][j]);
                }
            }
            if(Check(n)){
                solved=true;
                break;
            }
        }
        assert(solved);
        /*for(int i=1;i<=n;i++){
            if(!was[i]){
                DFS(i);
            }
        }
        for(int i=1;i<=n;i++){
            for(int j:E[i]){
                printf("%i -> %i col:%i\n",i,j,col[i][j]);
            }
        }*/
        printf("3\n");
        Print(0,1,n);
        Print(1,2,n);
        Print(2,0,n);

        for(int i=1;i<=n;i++){
            E[i].clear();
            G[i].clear();
            was[i]=false;
            in[i]=false;
            dep[i]=0;
        }
    }
    return 0;
}
